import{s as N,n as S,o as C}from"../chunks/scheduler.22bf70d2.js";import{S as q,i as z,g as c,s as m,r as U,A as F,h as d,f as t,c as u,j as $,u as A,x as E,k as T,y as k,a as o,v as G,d as I,t as O,w as D}from"../chunks/index.59178e06.js";import{D as R}from"../chunks/Docstring.cefe8221.js";import{H as j}from"../chunks/Heading.f8746c79.js";function B(L){let n,f,h,g,r,x,l,H='These docs refer to the <a href="https://github.com/PyTorch/PiPPy" rel="nofollow">PiPPy</a> integration.',y,s,p,P,i,M="Wraps <code>model</code> for pipeline parallel inference.",b,_,v;return r=new j({props:{title:"The inference API",local:"accelerate.prepare_pippy",headingTag:"h1"}}),p=new R({props:{name:"accelerate.prepare_pippy",anchor:"accelerate.prepare_pippy",parameters:[{name:"model",val:""},{name:"split_points",val:": Union = 'auto'"},{name:"no_split_module_classes",val:": Optional = None"},{name:"example_args",val:": Optional = ()"},{name:"example_kwargs",val:": Optional = None"},{name:"num_chunks",val:": Optional = None"},{name:"gather_output",val:": Optional = False"}],parametersDescription:[{anchor:"accelerate.prepare_pippy.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A model we want to split for pipeline-parallel inference`,name:"model"},{anchor:"accelerate.prepare_pippy.split_points",description:`<strong>split_points</strong> (<code>str</code> or <code>List[str]</code>, defaults to &#x2018;auto&#x2019;) &#x2014;
How to generate the split points and chunk the model across each GPU. &#x2018;auto&#x2019; will find the best balanced
split given any model. Should be a list of layer names in the model to split by otherwise.`,name:"split_points"},{anchor:"accelerate.prepare_pippy.no_split_module_classes",description:`<strong>no_split_module_classes</strong> (<code>List[str]</code>) &#x2014;
A list of class names for layers we don&#x2019;t want to be split.`,name:"no_split_module_classes"},{anchor:"accelerate.prepare_pippy.example_args",description:`<strong>example_args</strong> (tuple of model inputs) &#x2014;
The expected inputs for the model that uses order-based inputs. Recommended to use this method if possible.`,name:"example_args"},{anchor:"accelerate.prepare_pippy.example_kwargs",description:`<strong>example_kwargs</strong> (dict of model inputs) &#x2014;
The expected inputs for the model that uses dictionary-based inputs. This is a <em>highly</em> limiting structure
that requires the same keys be present at <em>all</em> inference calls. Not recommended unless the prior condition
is true for all cases.`,name:"example_kwargs"},{anchor:"accelerate.prepare_pippy.num_chunks",description:`<strong>num_chunks</strong> (<code>int</code>, defaults to the number of available GPUs) &#x2014;
The number of different stages the Pipeline will have. By default it will assign one chunk per GPU, but
this can be tuned and played with. In general one should have num_chunks &gt;= num_gpus.`,name:"num_chunks"},{anchor:"accelerate.prepare_pippy.gather_output",description:`<strong>gather_output</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, the output from the last GPU (which holds the true outputs) is sent across to all GPUs.`,name:"gather_output"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.3/src/accelerate/inference.py#L126"}}),{c(){n=c("meta"),f=m(),h=c("p"),g=m(),U(r.$$.fragment),x=m(),l=c("p"),l.innerHTML=H,y=m(),s=c("div"),U(p.$$.fragment),P=m(),i=c("p"),i.innerHTML=M,b=m(),_=c("p"),this.h()},l(e){const a=F("svelte-u9bgzb",document.head);n=d(a,"META",{name:!0,content:!0}),a.forEach(t),f=u(e),h=d(e,"P",{}),$(h).forEach(t),g=u(e),A(r.$$.fragment,e),x=u(e),l=d(e,"P",{"data-svelte-h":!0}),E(l)!=="svelte-x3n7zx"&&(l.innerHTML=H),y=u(e),s=d(e,"DIV",{class:!0});var w=$(s);A(p.$$.fragment,w),P=u(w),i=d(w,"P",{"data-svelte-h":!0}),E(i)!=="svelte-1pc33ak"&&(i.innerHTML=M),w.forEach(t),b=u(e),_=d(e,"P",{}),$(_).forEach(t),this.h()},h(){T(n,"name","hf:doc:metadata"),T(n,"content",V),T(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){k(document.head,n),o(e,f,a),o(e,h,a),o(e,g,a),G(r,e,a),o(e,x,a),o(e,l,a),o(e,y,a),o(e,s,a),G(p,s,null),k(s,P),k(s,i),o(e,b,a),o(e,_,a),v=!0},p:S,i(e){v||(I(r.$$.fragment,e),I(p.$$.fragment,e),v=!0)},o(e){O(r.$$.fragment,e),O(p.$$.fragment,e),v=!1},d(e){e&&(t(f),t(h),t(g),t(x),t(l),t(y),t(s),t(b),t(_)),t(n),D(r,e),D(p)}}}const V='{"title":"The inference API","local":"accelerate.prepare_pippy","sections":[],"depth":1}';function W(L){return C(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Y extends q{constructor(n){super(),z(this,n,W,B,N,{})}}export{Y as component};
